# Kante
declaration: package: graph, class: Kante

Package graph

# Class Kante

java.lang.Object
graph.GraphElement
graph.Kante

All Implemented Interfaces:
  `Comparable<graph.GraphElement>`

public class Kante extends graph.GraphElement
Die Klasse Kante beschreibt die Datenstruktur einer Kante, bestehend aus Startknoten, Gewicht und Zielknoten. Da Kanten innerhalb von Adjazenzlisten und -Matrizen repraesentiert werden, ist diese Klasse eigentlich unnoetig! Sie wurde zum Zweck der Vereinfachung - sozusagen als Zwischenspeicher von Kanten - eingefuehrt. Auch soll sie das Kantengewicht verwalten und Aufschluss darueber geben, ob sie gefaerbt/geloescht ist oder nicht.

Version:
  28.02.2023 (v7.0) v7.0: Die Kanteninformationen werden in einer Hashmap gespeichert. Daher können beliebige weitere Informationen abgelegt werden.
Author:
  Dirk Zechnall, Thomas Schaller

## Field Summary

### Fields inherited from class graph.GraphElement

`daten, g, sortierKriterium, typen`

## Constructor Summary

Constructors
Constructor
Description
`Kante(graph.Knoten neuerStart, graph.Knoten neuerZiel, double neuesGewicht)`
Der Konstruktor erstellt eine neue Kante mit Start- und Zielknoten und Kantengewicht.

## Method Summary

Modifier and Type
Method
Description
`graph.Knoten`
`getAnderesEnde(graph.Knoten k)`
Gibt Knoten am anderen Ende der Kante zurueck
`int`
`getFarbe()`
Gibt zurueck, in welcher Farbe die Kante gezeichnet werden soll.
`double`
`getGewicht()`
Gibt das Gewicht der Kante zurueck
`List<String>`
`getKurztext(String[] namen)`
Liefert einen kurzen Text, der den Wert des Knotens angibt und innerhalb der Kreises des Knotens angezeigt werden kann.
`List<String>`
`getLangtext(String[] namen)`
Liefert eine ausführliche Beschreibung der Werte des Knoten.
`graph.Knoten`
`getStart()`
Gibt den Startknoten der Kante zurueck
`graph.Knoten`
`getZiel()`
Gibt den Zielknoten der Kante zurueck
`protected void`
`init()`
Die Methode init initialisiert die Kantenfaerbung (auf unmarkiert)
`boolean`
`isGeloescht()`
Gibt den gelöscht-Wert der Kante zurueck
`boolean`
`isMarkiert()`
Gibt zurück, ob die Kanten markiert ist
`void`
`setFarbe(int farbe)`
Setzt die Farbe auf einen bestimmten Farbindex
`void`
`setGeloescht(boolean wert)`
Setzt das gelöscht-Attribut der Kante
`void`
`setGewicht(double neuesGewicht)`
Setzt das Gewicht der Kante
`void`
`setMarkiert(boolean wert)`
Setzt das markiert-Attribut der Kante
`void`
`setStandardFarbe()`
Setzt die Farbe auf die Standardfarbgebung zurück
`void`
`setStart(graph.Knoten neuerStartKnoten)`
Setzt den Startknoten der Kante
`void`
`setZiel(graph.Knoten neuerZielKnoten)`
Setzt den Zielknoten der Kante
`String`
`toString()`
Die Methode ueberschreibt die Methode toString() und gibt die String-Raepraesentation einer Kante zurueck

### Methods inherited from class graph.GraphElement

`compareTo, getBoolean, getDouble, getInt, getStatus, getString, set, set, set, set, setGraph, setSortierkriterium, setStatus`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Kante

public Kante(graph.Knoten neuerStart, graph.Knoten neuerZiel, double neuesGewicht)
Der Konstruktor erstellt eine neue Kante mit Start- und Zielknoten und Kantengewicht. Die Kante ist zu Beginn ungefaerbt.

Parameters:
  `neuerStart` - Der neue Startknoten
  `neuerZiel` - Der neue Zielknoten
  `neuesGewicht` - Das neue Kantengewicht

## Method Details

### init

protected void init()
Die Methode init initialisiert die Kantenfaerbung (auf unmarkiert)

### getKurztext

public List<String> getKurztext(String[] namen)
Liefert einen kurzen Text, der den Wert des Knotens angibt und innerhalb der Kreises des Knotens angezeigt werden kann.

Specified by:
  `getKurztext` in class `graph.GraphElement`
Parameters:
  `namen` - Namen der Werte, die im Kurztext angezeigt werden sollen.
Returns:
  Array von Anzeigezeilen (dürfen max. 2 sein)

### getLangtext

public List<String> getLangtext(String[] namen)
Liefert eine ausführliche Beschreibung der Werte des Knoten. Wird in dem Tooltext Fenster angezeigt, wenn man mit der Maus über den Knoten geht.

Specified by:
  `getLangtext` in class `graph.GraphElement`
Parameters:
  `namen` - Namen der Werte, die im Tooltip angezeigt werden sollen.
Returns:
  Array von Anzeigezeilen

### setGewicht

public void setGewicht(double neuesGewicht)
Setzt das Gewicht der Kante

Parameters:
  `neuesGewicht` - Das neu zu setzende Gewicht

### getGewicht

public double getGewicht()
Gibt das Gewicht der Kante zurueck

Returns:
  Gewicht der Kante

### setStart

public void setStart(graph.Knoten neuerStartKnoten)
Setzt den Startknoten der Kante

Parameters:
  `neuerSatrtKnoten` - Der neu zu setzende Startknoten

### getStart

public graph.Knoten getStart()
Gibt den Startknoten der Kante zurueck

Returns:
  Startknoten

### setZiel

public void setZiel(graph.Knoten neuerZielKnoten)
Setzt den Zielknoten der Kante

Parameters:
  `neuerZielKnoten` - Der neu zu setzende Zielknoten

### getZiel

public graph.Knoten getZiel()
Gibt den Zielknoten der Kante zurueck

Returns:
  Zielknoten

### getAnderesEnde

public graph.Knoten getAnderesEnde(graph.Knoten k)
Gibt Knoten am anderen Ende der Kante zurueck

Parameters:
  `k` - Knoten am ersten Ende der Kante
Returns:
  Knoten am anderen Ende

### setMarkiert

public void setMarkiert(boolean wert)
Setzt das markiert-Attribut der Kante

Parameters:
  `wert` - Der neu zu setzende markiert-Wert

### isMarkiert

public boolean isMarkiert()
Gibt zurück, ob die Kanten markiert ist

Returns:
  markiert?

### setGeloescht

public void setGeloescht(boolean wert)
Setzt das gelöscht-Attribut der Kante

Parameters:
  `wert` - Der neu zu setzende gelöscht-Wert

### isGeloescht

public boolean isGeloescht()
Gibt den gelöscht-Wert der Kante zurueck

Returns:
  gelöscht?

### getFarbe

public int getFarbe()
Gibt zurueck, in welcher Farbe die Kante gezeichnet werden soll. Ist die Farbe nicht gesetzt, dann wird eine unmarkierte Kante in Farbe 1 und eine markierte in Farbe 2 gezeichnet.

Returns:
  Nummer der Farbe

### setFarbe

public void setFarbe(int farbe)
Setzt die Farbe auf einen bestimmten Farbindex

Parameters:
  `farbe` - Index der Farbe (0-19)

### setStandardFarbe

public void setStandardFarbe()
Setzt die Farbe auf die Standardfarbgebung zurück

### toString

public String toString()
Die Methode ueberschreibt die Methode toString() und gibt die String-Raepraesentation einer Kante zurueck

Overrides:
  `toString` in class `Object`
Returns:
  String-Raepraesentation der Kante